"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupOfPropertiesBuilder = void 0;
const group_of_properties_rule_builder_1 = require("./group-of-properties-rule-builder");
class GroupOfPropertiesBuilder {
    constructor(propertyGroup) {
        this.propertyGroup = propertyGroup;
    }
    template(propertiesOfGroup, ...rulesDefintions) {
        return (id, index, siblingAccess) => {
            const group = this.propertyGroup(id, propertiesOfGroup(suffix => `${id}_${suffix}`, index, siblingAccess));
            this.bind(group, ...rulesDefintions);
            return group;
        };
    }
    of(id, propertiesOfGroup, ...rulesDefintions) {
        const group = this.propertyGroup(id, propertiesOfGroup);
        this.bind(group, ...rulesDefintions);
        return group;
    }
    bind(prop, ...rulesDefintions) {
        const builder = new group_of_properties_rule_builder_1.GroupOfPropertiesRuleBuilder(prop);
        rulesDefintions.forEach(def => def.apply(builder));
    }
}
exports.GroupOfPropertiesBuilder = GroupOfPropertiesBuilder;
