import { AbstractProperty } from "./abstract-property";
import { GroupOfProperties } from "./group-of-properties";
import { ListOfProperties } from "./list-of-properties";
import { PropertyScalar } from "./property-scalar";
export declare type DataTypeToPropertyGroup<D extends Record<string, unknown>> = {
    [K in keyof D]: DataTypeAsProperty<D[K]>;
};
export declare type DataTypeAsProperty<D> = D extends (infer E)[] ? ListOfProperties<DataTypeAsProperty<E>, E> : D extends Record<string, unknown> ? GroupOfProperties<{
    [K in keyof D]: DataTypeAsProperty<D[K]>;
}> : D extends boolean ? PropertyScalar<boolean> : D extends string ? PropertyScalar<D> : D extends number ? PropertyScalar<D> : D extends Date ? PropertyScalar<Date> : AbstractDataProperty<D>;
export declare type DataTypeOfProperty<T> = T extends AbstractDataProperty<infer D> ? D : unknown;
export interface AbstractDataProperty<D> extends AbstractProperty {
    setToInitialState(): void;
    exportData(): D | null;
    importData(data: D | null): void;
    transferData(toProperty: AbstractDataProperty<D>): void;
}
