"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupOfPropertiesImpl = void 0;
const abstract_property_impl_1 = require("./abstract-property-impl");
class GroupOfPropertiesImpl extends abstract_property_impl_1.AbstractPropertyImpl {
    constructor(id, properties, updateHandler) {
        super(updateHandler);
        this.id = id;
        this.properties = properties;
        this.propertiesAsList = Object.keys(this.properties).map(propKey => this.properties[propKey]);
    }
    internallySyncUpdate() {
        throw new Error("Method not implemented.");
    }
    internallyAsyncUpdate() {
        throw new Error("Method not implemented.");
    }
    isValid() {
        return super.isValid() && Object.keys(this.properties).every(k => this.properties[k].isValid());
    }
    isProcessing() {
        return Object.keys(this.properties).some(k => this.properties[k].isProcessing());
    }
    isReadOnly() {
        return Object.keys(this.properties).every(k => this.properties[k].isReadOnly());
    }
    isAsynchronous() {
        return Object.keys(this.properties).some(k => this.properties[k].isAsynchronous());
    }
    setToInitialState() {
        this.propertiesAsList.forEach(prop => prop.setToInitialState());
    }
    exportData() {
        return Object.keys(this.properties).reduce((res, cur) => {
            res[cur] = this.properties[cur].exportData();
            return res;
        }, {});
    }
    importData(data) {
        if (data != null) {
            Object.keys(this.properties).forEach(key => {
                this.properties[key].importData(data[key]);
            });
        }
        this.needsAnUpdate();
    }
}
exports.GroupOfPropertiesImpl = GroupOfPropertiesImpl;
