import { AbstractPropertyImpl } from "./abstract-property-impl";
import { ListOfProperties } from "./list-of-properties";
import { RuleEngineUpdateHandler } from "../engine/rule-engine-update-handler-impl";
import { OwnerRelation } from "../dependency-graph/dependency-graph";
import { AbstractDataProperty } from "./abstract-data-property";
import { PropertyTemplate } from "./factory/property-template";
import { SiblingAccess } from "../provider/list-provider/sibling-access";
export declare class ListOfPropertiesImpl<T extends AbstractDataProperty<D>, D> extends AbstractPropertyImpl<(D | null)[]> implements ListOfProperties<T, D>, SiblingAccess<T> {
    readonly id: string;
    private readonly propertyTemplate;
    private readonly isMultiSelect;
    private readonly ownerRelation;
    private internalList;
    readonly siblingCount: number;
    private readonly singleSelection?;
    private nxtId;
    get length(): number;
    get list(): T[];
    constructor(id: string, propertyTemplate: PropertyTemplate<T, D>, isMultiSelect: boolean, updateHandler: RuleEngineUpdateHandler, ownerRelation: OwnerRelation);
    protected internallySyncUpdate(): void;
    protected internallyAsyncUpdate<V>(): {
        asyncPromise: Promise<V>;
        resolve: (value: V) => void;
    };
    getProperty(index: number): T | undefined;
    addProperty(property?: T, atIndex?: number, dontNotify?: boolean): T;
    addProperties(properties: number | T[], atIndex?: number): T[];
    addPropertyData(data: (D | null)[], atIndex?: number): T[];
    private addPropertyInternal;
    private adjustIndices;
    updatePropertyData(data: D | null, atIndex: number): void;
    updateProperty(property: AbstractDataProperty<D>, atIndex: number): void;
    swapProperties(indexA: number, indexB: number): void;
    moveProperty(fromIndex: number, toIndex: number): void;
    private movePropertyInternal;
    removePropertyAtIndex(index: number): T | undefined;
    removeProperty(property: T): boolean;
    selectPropertyAtIndex(index: number): void;
    selectProperty(property: T): void;
    isPropertySelectedAtIndex(index: number): boolean;
    isPropertySelected(property: T): boolean;
    getSelectedIndices(): number[];
    getSelectedProperties(): {
        property: T;
        index: number;
    }[];
    getSelectedProperty(): {
        property: T;
        index: number;
    } | undefined;
    unselectPropertyAtIndex(index: number): void;
    unselectProperty(property: T | undefined): void;
    unselectAll(): void;
    isProcessing(): boolean;
    isReadOnly(): boolean;
    isAsynchronous(): boolean;
    getSibling(atIndex: number): T | undefined;
    someSibling(predicate: (sibling: T, index?: number) => unknown): boolean;
    everySibling(predicate: (sibling: T, index?: number) => unknown): boolean;
    reduceSiblings<R>(callbackfn: (previousValue: R, sibling: T, index?: number) => R, initialValue: R): R;
    filterSiblings(predicate: (sibling: T, index?: number) => unknown): T[];
    setToInitialState(): void;
    exportData(): (D | null)[];
    importData(data: (D | null)[]): void;
}
