"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddOperation = void 0;
const operation_1 = require("./operation");
class AddOperation extends operation_1.ListOperation {
    constructor(sync, element, index) {
        super(sync);
        this.sync = sync;
        this.element = element;
        this.index = index;
    }
    apply(list) {
        if (this.index !== undefined) {
            list.splice(this.index, 0, this.element);
        }
        else {
            this.index = list.length;
            list.push(this.element);
        }
    }
    undo(list) {
        if (this.index) {
            list.splice(this.index, 1);
        }
    }
}
exports.AddOperation = AddOperation;
