"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RemoveOperation = void 0;
const operation_1 = require("./operation");
class RemoveOperation extends operation_1.ListOperation {
    constructor(sync, index) {
        super(sync);
        this.sync = sync;
        this.index = index;
    }
    apply(list) {
        const [removed] = list.splice(this.index, 1);
        this.removed = removed;
    }
    undo(list) {
        if (this.removed) {
            list.splice(this.index, 0, this.removed);
        }
    }
}
exports.RemoveOperation = RemoveOperation;
