"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateOperation = void 0;
const operation_1 = require("./operation");
class UpdateOperation extends operation_1.ListOperation {
    constructor(sync, update, index) {
        super(sync);
        this.sync = sync;
        this.update = update;
        this.index = index;
    }
    apply(list) {
        const [old] = list.splice(this.index, 1, this.update);
        this.old = old;
    }
    undo(list) {
        if (this.old) {
            list.splice(this.index, 1, this.old);
        }
    }
}
exports.UpdateOperation = UpdateOperation;
