import { AbstractProperty } from "../../properties/abstract-property";
import { ListProvider } from "./list-provider";
export declare class CrudListProvider<T, Dependencies extends readonly AbstractProperty[]> implements ListProvider<T> {
    private readonly dependencies;
    private readonly resourceProvider;
    private resource?;
    constructor(dependencies: Dependencies, resourceProvider: (dependencies: Dependencies) => T[]);
    getProperties(): T[];
    addProperty(propertyData: T, index?: number): void;
    updateProperty(propertyData: T, index: number): void;
    removeProperty(index: number): void;
    isAsynchronous(): boolean;
    isProcessing(): boolean;
    shouldBeCached(): boolean;
    isReadOnly(): boolean;
}
