"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrudListProvider = void 0;
class CrudListProvider {
    constructor(dependencies, resourceProvider) {
        this.dependencies = dependencies;
        this.resourceProvider = resourceProvider;
    }
    getProperties() {
        this.resource = this.resourceProvider(this.dependencies);
        return this.resource;
    }
    addProperty(propertyData, index) {
        if (this.resource) {
            if (index !== undefined) {
                this.resource.splice(index, 0, propertyData);
            }
            else {
                this.resource.push(propertyData);
            }
        }
    }
    updateProperty(propertyData, index) {
        if (this.resource) {
            this.resource.splice(index, 1, propertyData);
        }
    }
    removeProperty(index) {
        if (this.resource) {
            this.resource.splice(index, 1);
        }
    }
    isAsynchronous() {
        return false;
    }
    isProcessing() {
        return false;
    }
    shouldBeCached() {
        return false;
    }
    isReadOnly() {
        return false;
    }
}
exports.CrudListProvider = CrudListProvider;
