import { AbstractProperty } from "../../properties/abstract-property";
import { AsyncListProvider } from "./list-provider";
export declare class DerivedAsyncListProvider<T, Dependencies extends readonly AbstractProperty[]> implements AsyncListProvider<T> {
    private readonly dependencies;
    private readonly properties;
    private processing;
    constructor(dependencies: Dependencies, properties: (dependencies: Dependencies) => Promise<T[]>);
    getProperties(): Promise<T[]>;
    addProperty(propertyData: T, index?: number): Promise<void>;
    updateProperty(propertyData: T, index: number): Promise<void>;
    removeProperty(index: number): Promise<void>;
    isAsynchronous(): boolean;
    isProcessing(): boolean;
    shouldBeCached(): boolean;
    isReadOnly(): boolean;
}
