"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DerivedAsyncListProvider = void 0;
class DerivedAsyncListProvider {
    constructor(dependencies, properties) {
        this.dependencies = dependencies;
        this.properties = properties;
        this.processing = false;
    }
    getProperties() {
        this.processing = true;
        return this.properties(this.dependencies).then((result) => {
            return result;
        }).finally(() => {
            this.processing = false;
        });
    }
    addProperty(propertyData, index) {
        return Promise.resolve();
    }
    updateProperty(propertyData, index) {
        return Promise.resolve();
    }
    removeProperty(index) {
        return Promise.resolve();
    }
    isAsynchronous() {
        return true;
    }
    isProcessing() {
        return this.processing;
    }
    shouldBeCached() {
        return false;
    }
    isReadOnly() {
        return true;
    }
}
exports.DerivedAsyncListProvider = DerivedAsyncListProvider;
