import { Provider } from "../provider";
export interface AsyncListProvider<D> extends Provider {
    getProperties(): Promise<D[]>;
    addProperty(propertyData: D, index?: number): Promise<void>;
    updateProperty(propertyData: D, index: number): Promise<void>;
    removeProperty(index: number): Promise<void>;
}
export interface ListProvider<D> extends Provider {
    getProperties(): D[];
    addProperty(propertyData: D, index?: number): void;
    updateProperty(propertyData: D, index: number): void;
    removeProperty(index: number): void;
}
