import { AbstractProperty } from "../properties/abstract-property";
export interface RulesDefinition<RuleBuilder> {
    apply(builder: RuleBuilder): void;
}
export declare class RulesDefinitionWithDependencies<RuleBuilder, Dependencies extends readonly AbstractProperty[]> implements RulesDefinition<RuleBuilder> {
    protected dependencies: Dependencies;
    protected readonly applyFcn: (builder: RuleBuilder, ...dependencies: Dependencies) => void;
    constructor(dependencies: Dependencies, applyFcn: (builder: RuleBuilder, ...dependencies: Dependencies) => void);
    apply(builder: RuleBuilder): void;
}
export declare class RulesDefinitionComposition<RuleBuilder> implements RulesDefinition<RuleBuilder> {
    private readonly definitions;
    constructor(definitions: RulesDefinition<RuleBuilder>[]);
    apply(builder: RuleBuilder): void;
}
export declare class AbstractRulesDefinition<RuleBuilder> implements RulesDefinition<RuleBuilder> {
    private implementation?;
    apply(builder: RuleBuilder): void;
    implementWith(implementation: RulesDefinition<RuleBuilder>): void;
}
