"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractRulesDefinition = exports.RulesDefinitionComposition = exports.RulesDefinitionWithDependencies = void 0;
class RulesDefinitionWithDependencies {
    constructor(dependencies, applyFcn) {
        this.dependencies = dependencies;
        this.applyFcn = applyFcn;
    }
    apply(builder) {
        this.applyFcn(builder, ...this.dependencies);
    }
}
exports.RulesDefinitionWithDependencies = RulesDefinitionWithDependencies;
class RulesDefinitionComposition {
    constructor(definitions) {
        this.definitions = definitions;
    }
    apply(builder) {
        this.definitions.forEach(def => def.apply(builder));
    }
}
exports.RulesDefinitionComposition = RulesDefinitionComposition;
class AbstractRulesDefinition {
    apply(builder) {
        if (!this.implementation) {
            throw new Error("No implementation provided");
        }
        this.implementation.apply(builder);
    }
    implementWith(implementation) {
        this.implementation = implementation;
    }
}
exports.AbstractRulesDefinition = AbstractRulesDefinition;
