import { GroupOfPropertiesTemplate } from "../../properties/factory/property-template";
import { PropertyGroup, GroupOfProperties } from "../../properties/group-of-properties";
import { ListIndex } from "../../properties/lists/index/list-index";
import { GroupOfPropertiesImpl } from "../../properties/group-of-properties-impl";
import { SiblingAccess } from "../../provider/list-provider/sibling-access";
import { GroupOfPropertiesRulesDefinition } from "../../rules/group-of-properties-rules-definition";
export declare class GroupOfPropertiesBuilder {
    private readonly propertyGroup;
    constructor(propertyGroup: <T extends PropertyGroup>(id: string, properties: T) => GroupOfPropertiesImpl<T>);
    template<T extends PropertyGroup>(propertiesOfGroup: (idFcn: (id: string) => string, index?: ListIndex, siblingAccess?: SiblingAccess<GroupOfProperties<T>>) => T, ...rulesDefintions: GroupOfPropertiesRulesDefinition<T>[]): GroupOfPropertiesTemplate<T>;
    of<T extends PropertyGroup>(id: string, propertiesOfGroup: T, ...rulesDefintions: GroupOfPropertiesRulesDefinition<T>[]): GroupOfProperties<T>;
    bind<T extends PropertyGroup>(prop: GroupOfProperties<T>, ...rulesDefintions: GroupOfPropertiesRulesDefinition<T>[]): void;
}
