import { GroupOfPropertiesRuleBuilder } from "./group-of-properties-rule-builder";
export class GroupOfPropertiesBuilder {
    constructor(propertyGroup) {
        this.propertyGroup = propertyGroup;
    }
    template(propertiesOfGroup, ...rulesDefintions) {
        return (id, index, siblingAccess) => {
            const group = this.propertyGroup(id, propertiesOfGroup(suffix => `${id}_${suffix}`, index, siblingAccess));
            this.bind(group, ...rulesDefintions);
            return group;
        };
    }
    of(id, propertiesOfGroup, ...rulesDefintions) {
        const group = this.propertyGroup(id, propertiesOfGroup);
        this.bind(group, ...rulesDefintions);
        return group;
    }
    bind(prop, ...rulesDefintions) {
        const builder = new GroupOfPropertiesRuleBuilder(prop);
        rulesDefintions.forEach(def => def.apply(builder));
    }
}
