export class GroupOfPropertiesRuleBuilder {
    constructor(property) {
        this.property = property;
    }
    addValidator(validator) {
        this.property.addSinglePropertyValidator(validator);
        return this;
    }
    addGeneralValidator(validator) {
        const instance = {
            getValidatedProperties: () => this.property.propertiesAsList,
            validate: () => validator(this.property.properties)
        };
        this.property.addValidator(instance);
        return this;
    }
}
