export class ListOfPropertiesRuleBuilder {
    constructor(property) {
        this.property = property;
    }
    addValidator(validator) {
        this.property.addSinglePropertyValidator(validator);
        return this;
    }
    addAsyncValidator(validator) {
        const propList = [this.property];
        this.property.addValidator({
            getValidatedProperties: () => propList,
            validate: (prop) => validator(prop)
        });
        return this;
    }
}
