import { AbstractPropertyImpl } from "./abstract-property-impl";
import { PropertyGroup, GroupOfProperties, PropertyGroupData } from "./group-of-properties";
import { RuleEngineUpdateHandler } from "../engine/rule-engine-update-handler-impl";
import { AbstractDataProperty } from "./abstract-data-property";
export declare class GroupOfPropertiesImpl<T extends PropertyGroup> extends AbstractPropertyImpl<PropertyGroupData<T>> implements GroupOfProperties<T> {
    readonly id: string;
    readonly properties: T;
    readonly propertiesAsList: readonly AbstractDataProperty<unknown>[];
    constructor(id: string, properties: T, updateHandler: RuleEngineUpdateHandler);
    protected internallySyncUpdate(): void;
    protected internallyAsyncUpdate<V>(): {
        asyncPromise: Promise<V>;
        resolve: (value: V) => void;
    };
    isValid(): boolean;
    isProcessing(): boolean;
    isReadOnly(): boolean;
    isAsynchronous(): boolean;
    setToInitialState(): void;
    exportData(): PropertyGroupData<T> | null;
    importData(data: PropertyGroupData<T> | null): void;
}
