import { ListOperation } from "./operation";
export class RemoveOperation extends ListOperation {
    constructor(sync, index) {
        super(sync);
        this.sync = sync;
        this.index = index;
    }
    apply(list) {
        const [removed] = list.splice(this.index, 1);
        this.removed = removed;
    }
    undo(list) {
        if (this.removed) {
            list.splice(this.index, 0, this.removed);
        }
    }
}
