import { ListOperation } from "./operation";
export class UpdateOperation extends ListOperation {
    constructor(sync, update, index) {
        super(sync);
        this.sync = sync;
        this.update = update;
        this.index = index;
    }
    apply(list) {
        const [old] = list.splice(this.index, 1, this.update);
        this.old = old;
    }
    undo(list) {
        if (this.old) {
            list.splice(this.index, 1, this.old);
        }
    }
}
