import { AbstractProperty } from "./abstract-property";
import { Choice } from "./choice";
import { PropertyArrayListReadonly } from "./property-array-list";
import { PropertyScalar } from "./property-scalar";
export interface PropertyScalarWithChoices<T, V> extends PropertyScalar<T> {
    getChoices(): Choice<V>[];
    awaitChoices(): Promise<Choice<V>[]>;
}
export declare function isPropertyScalarWithChoices(property: AbstractProperty): property is PropertyScalarWithChoices<unknown, unknown>;
export declare const upgradeAsPropertyWithChoices: <T, V, S extends PropertyArrayListReadonly<Choice<V>>>(propertyScalar: PropertyScalar<T>, choicesSource: S | (() => Choice<V>[])) => PropertyScalarWithChoices<T, V>;
