import { PropertyArrayListAsyncImpl } from "./property-array-list-impl";
import { PropertyScalarImpl } from "./property-scalar-impl";
export function isPropertyScalarWithChoices(property) {
    return property instanceof PropertyScalarImpl && "getChoices" in property;
}
export const upgradeAsPropertyWithChoices = (propertyScalar, choicesSource) => {
    const upgradedProperty = propertyScalar;
    if (choicesSource instanceof Function) {
        upgradedProperty.getChoices = choicesSource;
        upgradedProperty.awaitChoices = () => Promise.resolve(choicesSource());
    }
    else {
        upgradedProperty.getChoices = () => choicesSource.getElements();
        if (choicesSource instanceof PropertyArrayListAsyncImpl) {
            upgradedProperty.awaitChoices = () => choicesSource.awaitElements().then(res => res !== null && res !== void 0 ? res : []);
            upgradedProperty.isProcessing = () => choicesSource.isProcessing();
        }
        else {
            upgradedProperty.awaitChoices = () => Promise.resolve(choicesSource.getElements());
        }
    }
    return upgradedProperty;
};
