import { AbstractProperty } from "../../properties/abstract-property";
import { AsyncListProvider } from "./list-provider";
export declare class CrudAsyncListProvider<T, Dependencies extends readonly AbstractProperty[]> implements AsyncListProvider<T> {
    private readonly dependencies;
    private readonly create;
    private readonly read;
    private readonly update;
    private readonly remove;
    private processing;
    constructor(dependencies: Dependencies, create: (propertyData: T, index?: number) => Promise<void>, read: (dependencies: Dependencies) => Promise<T[]>, update: (propertyData: T, index: number) => Promise<void>, remove: (index: number) => Promise<void>);
    getProperties(): Promise<T[]>;
    addProperty(propertyData: T, index?: number): Promise<void>;
    updateProperty(propertyData: T, index: number): Promise<void>;
    removeProperty(index: number): Promise<void>;
    isAsynchronous(): boolean;
    isProcessing(): boolean;
    shouldBeCached(): boolean;
    isReadOnly(): boolean;
}
