export class DerivedAsyncValueProvider {
    constructor(dependencies, get, set) {
        this.dependencies = dependencies;
        this.get = get;
        this.set = set;
        this.processing = false;
    }
    getValue() {
        this.processing = true;
        return this.get(this.dependencies).then(result => {
            return result;
        }).finally(() => {
            this.processing = false;
        });
    }
    setValue(value) {
        if (this.set) {
            return this.set(value, ...this.dependencies);
        }
    }
    isAsynchronous() {
        return true;
    }
    isProcessing() {
        return this.processing;
    }
    shouldBeCached() {
        return true;
    }
    isReadOnly() {
        return !this.set;
    }
}
