import { PropertyArrayListRuleBuilder } from "../engine/builder/property-array-list-rule-builder";
import { AbstractProperty } from "../properties/abstract-property";
import { AbstractRulesDefinition, RulesDefinition } from "./rules-definition";
export declare type ArrayListRulesDefinition<T> = RulesDefinition<PropertyArrayListRuleBuilder<T>>;
export declare function arrayListRules<T>(apply: (builder: PropertyArrayListRuleBuilder<T>) => void): ArrayListRulesDefinition<T>;
export declare function arrayListRulesWithDeps<T, Dependencies extends readonly AbstractProperty[]>(apply: (builder: PropertyArrayListRuleBuilder<T>, ...dependencies: Dependencies) => void): (dependencies: Dependencies) => ArrayListRulesDefinition<T>;
export declare function arrayListRulesComposed<T>(...defintions: ArrayListRulesDefinition<T>[]): ArrayListRulesDefinition<T>;
export declare function arrayListRulesAbstract<T>(): AbstractRulesDefinition<PropertyArrayListRuleBuilder<T>>;
