import { GroupOfPropertiesRuleBuilder } from "../engine/builder/group-of-properties-rule-builder";
import { AbstractProperty } from "../properties/abstract-property";
import { PropertyGroup } from "../properties/group-of-properties";
import { AbstractRulesDefinition, RulesDefinition } from "./rules-definition";
export declare type GroupOfPropertiesRulesDefinition<T extends PropertyGroup> = RulesDefinition<GroupOfPropertiesRuleBuilder<T>>;
export declare function groupRules<T extends PropertyGroup>(apply: (builder: GroupOfPropertiesRuleBuilder<T>) => void): GroupOfPropertiesRulesDefinition<T>;
export declare function groupRulesWithDeps<T extends PropertyGroup, Dependencies extends readonly AbstractProperty[]>(apply: (builder: GroupOfPropertiesRuleBuilder<T>, ...dependencies: Dependencies) => void): (dependencies: Dependencies) => GroupOfPropertiesRulesDefinition<T>;
export declare function groupRulesComposed<T extends PropertyGroup>(...defintions: GroupOfPropertiesRulesDefinition<T>[]): GroupOfPropertiesRulesDefinition<T>;
export declare function groupRulesAbstract<T extends PropertyGroup>(): AbstractRulesDefinition<GroupOfPropertiesRuleBuilder<T>>;
