export class RulesDefinitionWithDependencies {
    constructor(dependencies, applyFcn) {
        this.dependencies = dependencies;
        this.applyFcn = applyFcn;
    }
    apply(builder) {
        this.applyFcn(builder, ...this.dependencies);
    }
}
export class RulesDefinitionComposition {
    constructor(definitions) {
        this.definitions = definitions;
    }
    apply(builder) {
        this.definitions.forEach(def => def.apply(builder));
    }
}
export class AbstractRulesDefinition {
    apply(builder) {
        if (!this.implementation) {
            throw new Error("No implementation provided");
        }
        this.implementation.apply(builder);
    }
    implementWith(implementation) {
        this.implementation = implementation;
    }
}
