import { PropertyScalarRuleBuilder } from "../engine/builder/property-scalar-rule-builder";
import { AbstractProperty } from "../properties/abstract-property";
import { AbstractRulesDefinition, RulesDefinition } from "./rules-definition";
export declare type ScalarRulesDefinition<T> = RulesDefinition<PropertyScalarRuleBuilder<T>>;
export declare function rules<T>(apply: (builder: PropertyScalarRuleBuilder<T>) => void): ScalarRulesDefinition<T>;
export declare function rulesWithDeps<T, Dependencies extends readonly AbstractProperty[]>(apply: (builder: PropertyScalarRuleBuilder<T>, ...dependencies: Dependencies) => void): (dependencies: Dependencies) => ScalarRulesDefinition<T>;
export declare function rulesComposed<T>(...defintions: ScalarRulesDefinition<T>[]): ScalarRulesDefinition<T>;
export declare function rulesAbstract<T>(): AbstractRulesDefinition<PropertyScalarRuleBuilder<T>>;
