import { GroupOfProperties, PropertyGroup } from "../index";
import { AbstractDataProperty } from "../properties/abstract-data-property";
import { ListOfProperties } from "../properties/list-of-properties";
import { PropertyArrayList } from "../properties/property-array-list";
import { PropertyScalar } from "../properties/property-scalar";
import { ValidationMessage } from "./validation-message";
export declare type SinglePropertyValidator<T extends AbstractDataProperty<unknown>> = (property: T) => ValidationMessage | void;
export declare type PropertyScalarValidator<T> = SinglePropertyValidator<PropertyScalar<T>>;
export declare type GroupOfPropertiesValidator<T extends PropertyGroup> = SinglePropertyValidator<GroupOfProperties<T>>;
export declare type PropertyArrayListValidator<T> = SinglePropertyValidator<PropertyArrayList<T>>;
export declare type ListOfPropertiesValidator<T extends AbstractDataProperty<D>, D> = SinglePropertyValidator<ListOfProperties<T, D>>;
